#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <cv.h>
#include <highgui.h>

int main(int argc, char *argv[])
{
	int redpixelcount = 0;

	if(argc < 4){
		printf("Usage error: a.out <REDLOWERLIMIT> <GREENUPPERLIMIT> <BLUEUPPERLIMIT>\n");
		exit(1);
	}	

	CvCapture* capture = cvCaptureFromCAM(CV_CAP_ANY);
	if(!capture){
		fprintf(stderr, "Error: capture is NULL \n");
		getchar();
		return -1;
	}

	IplImage* img = cvQueryFrame(capture); //load image from webcam capture
	IplImage* copy = cvCreateImage(cvGetSize(img),8,3); //create a new image of 8 bit 3 channel

	CvScalar s, c;
	
	printf("Searching for Red pixels...\n");
	
	for(int i=0;i<(img->height);i++){ //in the 2d array of the image.. count till the vertical pixel reaches the height of img
		for(int j=0;j<(img->width);j++){ //in the 2d array of the image.. count till horizontal pixel reaches the width of img
			s=cvGet2D(img,i,j); //get the RGB values of img's i,j, into a scalar container, s
			if((s.val[2]>atoi(&*argv[1]))&&(s.val[1]<atoi(&*argv[2]))&&(s.val[0]<atoi(&*argv[3]))){//if(RED>redlower && GREEN<greenupper && BLUE<blueupper)

				c.val[2] = s.val[2];
				c.val[1] = s.val[1];
				c.val[0] = s.val[0];
				cvSet2D(copy,i,j,c); //make the corresponding pixel 100% red in the img copy
				redpixelcount++;
			}
			else
			{
				c.val[2] = 255;
				c.val[1] = 255;
				c.val[0] = 255;
				cvSet2D(copy,i,j,c);
			}
		}
	}
	printf("Red pixel count is: %d \n", redpixelcount);

	cvSaveImage("original.jpg",img);	
	cvSaveImage("redDetect.jpg",copy);

	/*cvNamedWindow("Input",CV_WINDOW_AUTOSIZE); //make a new window
	cvShowImage( "Input", img ); //Display img in a window named “Input”
	cvNamedWindow( "Output", CV_WINDOW_AUTOSIZE ); //Create a window “Output”
	cvShowImage( "Output", copy ); //Display copy in a window named “Output”
	cvWaitKey(); //Wait till the user presses a key or cvWaitKey(10) will wait for 10ms*/
	cvReleaseImage( &img );
	cvReleaseCapture(&capture);
	return 0;
}
